﻿Type.registerNamespace("Jeffz.Framework");

Jeffz.Framework.History = function(setDataCallback, helperPageUrl)
{
	if (!setDataCallback || (typeof setDataCallback != "function"))
	{
		throw new Error("Please provide a callback function");
	}

	this.__setDataCallback = setDataCallback;
	this.__currentHash = null;
	this.__helperIFrame = null;
	this.__helperPageUrl = helperPageUrl;
	this.__runtimeTimer = null;
	
	if (Sys.Runtime.get_hostType() == Sys.HostType.InternetExplorer)
	{
		if (!helperPageUrl)
		{
			throw new Error("Please provide the helper page for IE.");
		}
		else
		{
			var helperIFrame = document.createElement("iframe");
			helperIFrame.style.display = "none";
			document.body.appendChild(helperIFrame);
			this.__helperIFrame = helperIFrame;
			this.__reloadHelperIFrame(location.hash);
		}
	}
	else
	{
		this.__currentHash = location.hash;
		this.__execute(location.hash);
	}
}

Jeffz.Framework.History.prototype.__reloadHelperIFrame = function(hash)
{
	this.__helperIFrame.document.title = document.title;

	if (this.__helperIFrame.src && this.__helperIFrame.src.indexOf("?true") >= 0)
	{
		this.__helperIFrame.src = this.__helperPageUrl + "?false&" + document.title + hash;
	}
	else
	{
		this.__helperIFrame.src = this.__helperPageUrl + "?true&" + document.title + hash;
	}
}

Jeffz.Framework.History.prototype.__onTimerTick = function(sender, eventArgs)
{
	try
	{
		if (location.hash != sender.historyObj.__currentHash)
		{
			sender.historyObj.__currentHash = location.hash;
			sender.historyObj.__execute(location.hash);
		}
	}
	catch(e)
	{
		sender.set_enabled(false);
		sender.set_enabled(true);
		throw e;
	}
}

Jeffz.Framework.History.prototype.start = function()
{
	if (!this.__runtimeTimer)
	{
		var timer = new Sys.Timer();
		timer.set_interval(300);
		timer.tick.add(this.__onTimerTick);
		timer.historyObj = this;
		this.__runtimeTimer = timer;
	}
	
	if (this.__runtimeTimer.get_enabled())
	{
		throw new Error("The history object has been started.");
	}
	else
	{
		this.__runtimeTimer.set_enabled(true);
	}
}

Jeffz.Framework.History.prototype.stop = function()
{
	if (!this.__runtimeTimer || !this.__runtimerTimer.get_enabled())
	{
		throw new Error("The history object has not been started.");
	}
	else
	{
		this.__runtimeTimer.set_enabled(false);
	}
}

Jeffz.Framework.History.prototype.addHistory = function(context)
{
	historyEntry = { __p__ : context };

	if (Sys.Runtime.get_hostType() == Sys.HostType.InternetExplorer)
	{
		this.__reloadHelperIFrame("#" + encodeURI(Sys.Serialization.JSON.serialize(historyEntry)));
	}
	else
	{
		location.hash = encodeURI(Sys.Serialization.JSON.serialize(historyEntry));
	}
}

Jeffz.Framework.History.prototype.__execute = function(hash)
{
	var historyEntry = null;
	
	try
	{
		var historyEntry = Sys.Serialization.JSON.deserialize(decodeURI(hash.substring(1)));
	}
	catch(e)
	{
		this.__setDataCallback(null);
		return;
	}
	
	if (historyEntry)
	{
		this.__setDataCallback(historyEntry.__p__);
	}
	else
	{
		this.__setDataCallback(null);
	}
}